? xchm.patch
Index: about.docbook
===================================================================
RCS file: /sources/chmspec/chmspec/src/about.docbook,v
retrieving revision 1.10
diff -u -r1.10 about.docbook
--- about.docbook	1 Jun 2013 03:32:22 -0000	1.10
+++ about.docbook	6 Feb 2022 16:00:28 -0000
@@ -188,7 +188,7 @@
           <entry>Razvan Cojocaru</entry>
           <entry>No</entry>
           <entry><email>razvanco@gmx.net</email></entry>
-          <entry><ulink url="http://xchm.sourceforge.net/"/></entry>
+          <entry><ulink url="https://github.com/rzvncj/xCHM"/></entry>
         </row>
         <row id="Contributions_Deborah_Pickett">
           <entry>Deborah Pickett</entry>
Index: intern.docbook
===================================================================
RCS file: /sources/chmspec/chmspec/src/intern.docbook,v
retrieving revision 1.10
diff -u -r1.10 intern.docbook
--- intern.docbook	26 Feb 2011 02:56:10 -0000	1.10
+++ intern.docbook	6 Feb 2022 16:00:29 -0000
@@ -1159,7 +1159,7 @@
 
   <para>For CHM viewers that want to quickly find out which files a word is in, the procedure is as follows; read the header, seek to the root index node, search the root index node for a word that is less than or equal to the desired, descend to the next index level, repeat the previous two steps as many times as the tree is deep, then search the resulting leaf node until the desired word is found, read the correct part of the WLCs for that leaf node and extract the topic numbers for that word. Once all the topic numbers have been found for the desired words, make sure there are no duplicates and extract the titles and urls from the &toTOPICS;, &toURLTBL;, &toURLSTR; and &toSTRINGS; files.</para>
 
-  <para>For sample code for decoding &toFIftiMain; files, see <ulink url="http://savannah.gnu.org/projects/chmdeco">chmdeco</ulink>, <ulink url="http://xchm.sourceforge.net">xCHM</ulink> or <filename>dump_fiftimain.c</filename> from the <ulink url="http://savannah.gnu.org/projects/chmspec">old html versions</ulink> of this specification.</para>
+  <para>For sample code for decoding &toFIftiMain; files, see <ulink url="http://savannah.gnu.org/projects/chmdeco">chmdeco</ulink>, <ulink url="https://github.com/rzvncj/xCHM">xCHM</ulink> or <filename>dump_fiftimain.c</filename> from the <ulink url="http://savannah.gnu.org/projects/chmspec">old html versions</ulink> of this specification.</para>
 
   </section>
 
Index: intro.docbook
===================================================================
RCS file: /sources/chmspec/chmspec/src/intro.docbook,v
retrieving revision 1.6
diff -u -r1.6 intro.docbook
--- intro.docbook	26 Feb 2011 02:56:10 -0000	1.6
+++ intro.docbook	6 Feb 2022 16:00:29 -0000
@@ -68,7 +68,7 @@
           <entry>Current. Win98 - WinXP</entry>
           <entry><ulink url="http://savannah.gnu.org/projects/chmdeco">chmdeco</ulink>, <ulink url="http://morte.jedrea.com/~jedwin/projects/chmlib/">chmlib</ulink>, <ulink url="http://www.russotto.net/chm/">chmtools</ulink>, <ulink url="http://bonedaddy.net/pabs3/code/#istorage">istorage</ulink>, HHA/HHC/HHW, HH</entry>
           <entry>HHA/HHC/HHW, <ulink url="http://savannah.gnu.org/projects/hhm">hhm</ulink> (not yet)</entry>
-          <entry>HH, <ulink url="http://xchm.sf.net">xCHM</ulink>, <ulink url="http://archmage.sf.net">arCHMage</ulink>, <ulink url="http://morte.jedrea.com/~jedwin/projects/kio_msits/">msits kio slave</ulink>, <ulink url="http://www.herdsoft.com/linux/themen/chmviewer.html">chmviewer</ulink>, <ulink url="http://gnochm.sf.net/">GnoCHM</ulink>, <ulink url="http://chmsee.gro.clinux.org/">chmsee</ulink></entry>
+          <entry>HH, <ulink url="https://github.com/rzvncj/xCHM">xCHM</ulink>, <ulink url="http://archmage.sf.net">arCHMage</ulink>, <ulink url="http://morte.jedrea.com/~jedwin/projects/kio_msits/">msits kio slave</ulink>, <ulink url="http://www.herdsoft.com/linux/themen/chmviewer.html">chmviewer</ulink>, <ulink url="http://gnochm.sf.net/">GnoCHM</ulink>, <ulink url="http://chmsee.gro.clinux.org/">chmsee</ulink></entry>
           <entry>This document, <ulink url="http://www.russotto.net/chm/chmformat.html">ITSF format</ulink></entry>
         </row>
         <row id="MS_Help_2">
@@ -169,7 +169,7 @@
     <listitem><para>Jed Wing's <ulink url="http://morte.jedrea.com/~jedwin/projects/chmlib/">chmlib</ulink></para></listitem>
     <listitem><para>Jed Wing's <ulink url="http://morte.jedrea.com/~jedwin/projects/kio_msits/">KDE ms-its ioslave</ulink></para></listitem>
     <listitem><para>az's <ulink url="http://archmage.sf.net">arCHMage</ulink> (chm decompressor &amp; stuff)</para></listitem>
-    <listitem><para>Razvan Cojocaru's <ulink url="http://xchm.sf.net">xCHM</ulink> (chm viewer GUI for *nix/wxWindows)</para></listitem>
+    <listitem><para>Razvan Cojocaru's <ulink url="https://github.com/rzvncj/xCHM">xCHM</ulink> (chm viewer GUI for *nix/wxWindows)</para></listitem>
     <listitem><para>Pabs' <ulink url="http://bonedaddy.net/pabs3/code/#istorage">istorage</ulink></para></listitem>
     <listitem><para>Pabs' <ulink url="http://bonedaddy.net/pabs3/code/#istorage-make">istorage-make</ulink></para></listitem>
     <listitem><para>Pabs' <ulink url="http://savannah.gnu.org/projects/hhm">hhm</ulink></para></listitem>